package com.macaseinou.sample;

public class SingletonSample2 {

    private static int count = 0;
    
    // インスタンスの初期化はクラスロード時に行われる
    private static final SingletonSample2 instance = new SingletonSample2();

    // インスタンスの初期化に時間がかかる
    private SingletonSample2() {
        count++;
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {

        }
    }
    
    public static SingletonSample2 getInstance() {
        try {
            Thread.sleep(100);
        } catch (InterruptedException e) {

        }
        return SingletonSample2.instance;
    }
    
    public int getCount() {
        return count;
    }

}
